% demo script file 
% execution of  b6e6rl algorithm on selected test problems
% ========================================================
%
tol=1e-4; % tolerance f(x) for  f_near
s=420.968746;  % for schwefel0
d=10;  % dimension of the problem
%
%  select the test problem to be solved 
% 
% fn_name='ack_opr'; b=30*ones(1,d); cfn=0; cxst=zeros(1,d); f_near=cfn+tol;
% fn_name='ackley'; b=30*ones(1,d); cfn=0; cxst=zeros(1,d); f_near=cfn+tol;
% fn_name='rosen';  b=2.048*ones(1,d); cfn=0; cxst=ones(1,d);f_near=cfn+tol;
% fn_name='dejong1'; b=5.12*ones(1,d); cfn=0; cxst=zeros(1,d);f_near=cfn+tol;
 fn_name='griewank'; b=400*ones(1,d); cfn=0;  cxst=zeros(1,d);f_near=cfn+tol;
% fn_name='schwefel0'; b=500*ones(1,d); cfn=0; cxst=s*ones(1,d);f_near=cfn+tol;
% fn_name='rastrig';  b=5.12*ones(1,d); cfn=0; cxst=zeros(1,d);f_near=cfn+tol;
max_evals=20000; a=-b;
my_eps=1e-7;
N = 50;
n0 = 2;  delta= 1 /(12*5);
fid=fopen('result_file.010','a');  %  text file for recording the results
shift=zeros(1,d);
disp(fn_name);
for run=1:5
    disp('run'); disp(run);  %tim=cputime;
    % test function with the global minimum point in [0,0, ..., 0] 
    % are shifted:
    if strcmp(fn_name,'ackley') || strcmp(fn_name,'ack_opr')...
            || strcmp(fn_name,'griewank') ...
            || strcmp(fn_name,'rastrig') || strcmp(fn_name,'dejong1')
        shift=a+(b-a).*rand(1,d);
    end
    % call b6e6rl algorithm:
    % tic
    [xmin, fnmin, evals, success, func_near, nrst, cni]=...
        b6e6rl(fn_name, a, b, N, my_eps, max_evals, f_near, n0, delta, shift);
    %
    % time=toc;
    fprintf(fid,'%-10s', 'b6e6rl');
    fprintf(fid,'%-10s %4.0f', fn_name, d);
    fprintf(fid,'%5.0f %11.1e %8.0f ', N, my_eps, max_evals);
    fprintf(fid, '%4.0f  ', run);
    % fprintf(fid,'%8.1f',time);
    fprintf(fid,'%8.0f',evals);
    fprintf(fid,' %22.11e', fnmin);
    fprintf(fid,'%8.1f',100*success/evals);
    fprintf(fid,'%8.1f',100*func_near/evals);      
    fprintf(fid,'%8.0f ', nrst);
    fprintf(fid,'%1s\n',' ');
end
fclose(fid);
%
%
%
%
%
%
%
%
%
